Config (apache-cassandra API)
Date: 2018-02-12

org.apache.cassandra.config

## Class Config

- java.lang.Object
- - org.apache.cassandra.config.Config

-     public class Config
      extends java.lang.Object

  A class that contains configuration properties for the cassandra node it runs within. Properties declared as volatile can be mutated via JMX.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Config.CommitFailurePolicy`
    `static class` | `Config.CommitLogSync`
    `static class` | `Config.DiskAccessMode`
    `static class` | `Config.DiskFailurePolicy`
    `static class` | `Config.InternodeCompression`
    `static class` | `Config.MemtableAllocationType`
    `static class` | `Config.RequestSchedulerId`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `java.lang.String` | `authenticator`
    `java.lang.String` | `authorizer`
    `java.lang.Boolean` | `auto_bootstrap`
    `java.lang.Boolean` | `auto_snapshot`
    `int` | `batch_size_fail_threshold_in_kb`
    `int` | `batch_size_warn_threshold_in_kb`
    `int` | `batchlog_replay_throttle_in_kb`
    `java.lang.String` | `broadcast_address`
    `java.lang.String` | `broadcast_rpc_address`
    `java.lang.Long` | `cas_contention_timeout_in_ms`
    `EncryptionOptions.ClientEncryptionOptions` | `client_encryption_options`
    `java.lang.String` | `cluster_name`
    `java.lang.Integer` | `column_index_size_in_kb`
    `Config.CommitFailurePolicy` | `commit_failure_policy`
    `ParameterizedClass` | `commitlog_compression`
    `java.lang.String` | `commitlog_directory`
    `int` | `commitlog_max_compression_buffers_in_pool`
    `int` | `commitlog_periodic_queue_size` Deprecated.
    `int` | `commitlog_segment_size_in_mb`
    `Config.CommitLogSync` | `commitlog_sync`
    `java.lang.Double` | `commitlog_sync_batch_window_in_ms`
    `java.lang.Integer` | `commitlog_sync_period_in_ms`
    `java.lang.Integer` | `commitlog_total_space_in_mb`
    `java.lang.Integer` | `compaction_large_partition_warning_threshold_mb`
    `java.lang.Integer` | `compaction_throughput_mb_per_sec`
    `java.lang.Integer` | `concurrent_compactors`
    `java.lang.Integer` | `concurrent_counter_writes`
    `java.lang.Integer` | `concurrent_reads`
    `java.lang.Integer` | `concurrent_replicates` Deprecated.
    `java.lang.Integer` | `concurrent_writes`
    `int` | `counter_cache_keys_to_save`
    `int` | `counter_cache_save_period`
    `java.lang.Long` | `counter_cache_size_in_mb`
    `java.lang.Long` | `counter_write_request_timeout_in_ms`
    `boolean` | `cross_node_timeout`
    `java.lang.String[]` | `data_file_directories`
    `Config.DiskAccessMode` | `disk_access_mode`
    `Config.DiskFailurePolicy` | `disk_failure_policy`
    `java.lang.Boolean` | `dynamic_snitch`
    `java.lang.Double` | `dynamic_snitch_badness_threshold`
    `java.lang.Integer` | `dynamic_snitch_reset_interval_in_ms`
    `java.lang.Integer` | `dynamic_snitch_update_interval_in_ms`
    `boolean` | `enable_user_defined_functions`
    `EncryptionOptions.ServerEncryptionOptions` | `encryption_options`
    `java.lang.String` | `endpoint_snitch`
    `java.lang.Integer` | `file_cache_size_in_mb`
    `int` | `gc_log_threshold_in_ms`
    `int` | `gc_warn_threshold_in_ms`
    `java.lang.String` | `hinted_handoff_enabled`
    `java.util.Set<java.lang.String>` | `hinted_handoff_enabled_by_dc`
    `boolean` | `hinted_handoff_enabled_global`
    `int` | `hinted_handoff_throttle_in_kb`
    `boolean` | `incremental_backups`
    `java.lang.Integer` | `index_interval` Deprecated.
    `java.lang.Long` | `index_summary_capacity_in_mb`
    `int` | `index_summary_resize_interval_in_minutes`
    `java.lang.String` | `initial_token`
    `java.lang.Integer` | `inter_dc_stream_throughput_outbound_megabits_per_sec`
    `boolean` | `inter_dc_tcp_nodelay`
    `java.lang.String` | `internode_authenticator`
    `Config.InternodeCompression` | `internode_compression`
    `java.lang.Integer` | `internode_recv_buff_size_in_bytes`
    `java.lang.Integer` | `internode_send_buff_size_in_bytes`
    `int` | `key_cache_keys_to_save`
    `int` | `key_cache_save_period`
    `java.lang.Long` | `key_cache_size_in_mb`
    `java.lang.String` | `listen_address`
    `java.lang.String` | `listen_interface`
    `java.lang.Boolean` | `listen_interface_prefer_ipv6`
    `java.lang.Boolean` | `listen_on_broadcast_address`
    `java.lang.Integer` | `max_hint_window_in_ms`
    `int` | `max_hints_delivery_threads`
    `java.lang.Integer` | `max_streaming_retries` Deprecated. retry support removed on CASSANDRA-10992
    `java.lang.String` | `memory_allocator` Deprecated.
    `Config.MemtableAllocationType` | `memtable_allocation_type`
    `java.lang.Float` | `memtable_cleanup_threshold`
    `java.lang.Integer` | `memtable_flush_writers`
    `java.lang.Integer` | `memtable_heap_space_in_mb`
    `java.lang.Integer` | `memtable_offheap_space_in_mb`
    `java.lang.Long` | `native_transport_max_concurrent_connections`
    `java.lang.Long` | `native_transport_max_concurrent_connections_per_ip`
    `java.lang.Integer` | `native_transport_max_frame_size_in_mb`
    `java.lang.Integer` | `native_transport_max_threads`
    `java.lang.Integer` | `native_transport_port`
    `java.lang.Integer` | `num_tokens`
    `int` | `otc_coalescing_enough_coalesced_messages`
    `java.lang.String` | `otc_coalescing_strategy`
    `int` | `otc_coalescing_window_us`
    `static int` | `otc_coalescing_window_us_default`
    `protected static boolean` | `outboundBindAny` Deprecated. No longer needed for streaming protocol. See CASSANDRA-12673 for details.
    `java.lang.String` | `partitioner`
    `int` | `permissions_cache_max_entries`
    `int` | `permissions_update_interval_in_ms`
    `int` | `permissions_validity_in_ms`
    `java.lang.Double` | `phi_convict_threshold`
    `static java.lang.String` | `PROPERTY_PREFIX`
    `java.lang.Long` | `range_request_timeout_in_ms`
    `java.lang.Long` | `read_request_timeout_in_ms`
    `java.lang.String` | `request_scheduler`
    `Config.RequestSchedulerId` | `request_scheduler_id`
    `RequestSchedulerOptions` | `request_scheduler_options`
    `java.lang.Long` | `request_timeout_in_ms`
    `java.lang.String` | `role_manager`
    `int` | `roles_cache_max_entries`
    `int` | `roles_update_interval_in_ms`
    `int` | `roles_validity_in_ms`
    `java.lang.String` | `row_cache_class_name`
    `int` | `row_cache_keys_to_save`
    `int` | `row_cache_save_period`
    `long` | `row_cache_size_in_mb`
    `java.lang.String` | `rpc_address`
    `java.lang.String` | `rpc_interface`
    `java.lang.Boolean` | `rpc_interface_prefer_ipv6`
    `java.lang.Boolean` | `rpc_keepalive`
    `java.lang.Integer` | `rpc_listen_backlog`
    `java.lang.Integer` | `rpc_max_threads`
    `java.lang.Integer` | `rpc_min_threads`
    `java.lang.Integer` | `rpc_port`
    `java.lang.Integer` | `rpc_recv_buff_size_in_bytes`
    `java.lang.Integer` | `rpc_send_buff_size_in_bytes`
    `java.lang.String` | `rpc_server_type`
    `java.lang.String` | `saved_caches_directory`
    `ParameterizedClass` | `seed_provider`
    `EncryptionOptions.ServerEncryptionOptions` | `server_encryption_options`
    `java.lang.Boolean` | `snapshot_before_compaction`
    `java.lang.Integer` | `ssl_storage_port`
    `int` | `sstable_preemptive_open_interval_in_mb`
    `java.lang.Boolean` | `start_native_transport`
    `java.lang.Boolean` | `start_rpc`
    `java.lang.Integer` | `storage_port`
    `java.lang.Integer` | `stream_throughput_outbound_megabits_per_sec`
    `java.lang.Integer` | `streaming_socket_timeout_in_ms`
    `java.lang.Integer` | `thrift_framed_transport_size_in_mb`
    `java.lang.Integer` | `thrift_max_message_length_in_mb` Deprecated.
    `int` | `tombstone_failure_threshold`
    `int` | `tombstone_warn_threshold`
    `int` | `tracetype_query_ttl`
    `int` | `tracetype_repair_ttl`
    `boolean` | `trickle_fsync`
    `int` | `trickle_fsync_interval_in_kb`
    `java.lang.Long` | `truncate_request_timeout_in_ms`
    `java.lang.Integer` | `unlogged_batch_across_partitions_warn_threshold`
    `int` | `windows_timer_interval`
    `java.lang.Long` | `write_request_timeout_in_ms`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Config()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `configHintedHandoff()`
    `static boolean` | `getOutboundBindAny()`
    `static boolean` | `isClientMode()`
    `static void` | `log(Config config)`
    `static java.util.List<java.lang.String>` | `parseHintedHandoffEnabledDCs(java.lang.String dcNames)`
    `static void` | `setClientMode(boolean clientMode)`
    `static void` | `setOutboundBindAny(boolean value)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### PROPERTY_PREFIX

          public static final java.lang.String PROPERTY_PREFIX

      See Also:
        Constant Field Values

    - #### cluster_name

          public java.lang.String cluster_name

    - #### authenticator

          public java.lang.String authenticator

    - #### authorizer

          public java.lang.String authorizer

    - #### role_manager

          public java.lang.String role_manager

    - #### permissions_validity_in_ms

          public volatile int permissions_validity_in_ms

    - #### permissions_cache_max_entries

          public int permissions_cache_max_entries

    - #### permissions_update_interval_in_ms

          public volatile int permissions_update_interval_in_ms

    - #### roles_validity_in_ms

          public volatile int roles_validity_in_ms

    - #### roles_cache_max_entries

          public int roles_cache_max_entries

    - #### roles_update_interval_in_ms

          public volatile int roles_update_interval_in_ms

    - #### partitioner

          public java.lang.String partitioner

    - #### auto_bootstrap

          public java.lang.Boolean auto_bootstrap

    - #### hinted_handoff_enabled_global

          public volatile boolean hinted_handoff_enabled_global

    - #### hinted_handoff_enabled

          public java.lang.String hinted_handoff_enabled

    - #### hinted_handoff_enabled_by_dc

          public java.util.Set<java.lang.String> hinted_handoff_enabled_by_dc

    - #### max_hint_window_in_ms

          public volatile java.lang.Integer max_hint_window_in_ms

    - #### seed_provider

          public ParameterizedClass seed_provider

    - #### disk_access_mode

          public Config.DiskAccessMode disk_access_mode

    - #### disk_failure_policy

          public Config.DiskFailurePolicy disk_failure_policy

    - #### commit_failure_policy

          public Config.CommitFailurePolicy commit_failure_policy

    - #### initial_token

          public java.lang.String initial_token

    - #### num_tokens

          public java.lang.Integer num_tokens

    - #### request_timeout_in_ms

          public volatile java.lang.Long request_timeout_in_ms

    - #### read_request_timeout_in_ms

          public volatile java.lang.Long read_request_timeout_in_ms

    - #### range_request_timeout_in_ms

          public volatile java.lang.Long range_request_timeout_in_ms

    - #### write_request_timeout_in_ms

          public volatile java.lang.Long write_request_timeout_in_ms

    - #### counter_write_request_timeout_in_ms

          public volatile java.lang.Long counter_write_request_timeout_in_ms

    - #### cas_contention_timeout_in_ms

          public volatile java.lang.Long cas_contention_timeout_in_ms

    - #### truncate_request_timeout_in_ms

          public volatile java.lang.Long truncate_request_timeout_in_ms

    - #### streaming_socket_timeout_in_ms

          public java.lang.Integer streaming_socket_timeout_in_ms

    - #### cross_node_timeout

          public boolean cross_node_timeout

    - #### phi_convict_threshold

          public volatile java.lang.Double phi_convict_threshold

    - #### concurrent_reads

          public java.lang.Integer concurrent_reads

    - #### concurrent_writes

          public java.lang.Integer concurrent_writes

    - #### concurrent_counter_writes

          public java.lang.Integer concurrent_counter_writes

    - #### concurrent_replicates

          @Deprecated
          public java.lang.Integer concurrent_replicates

      Deprecated.

    - #### memtable_flush_writers

          public java.lang.Integer memtable_flush_writers

    - #### memtable_heap_space_in_mb

          public java.lang.Integer memtable_heap_space_in_mb

    - #### memtable_offheap_space_in_mb

          public java.lang.Integer memtable_offheap_space_in_mb

    - #### memtable_cleanup_threshold

          public java.lang.Float memtable_cleanup_threshold

    - #### storage_port

          public java.lang.Integer storage_port

    - #### ssl_storage_port

          public java.lang.Integer ssl_storage_port

    - #### listen_address

          public java.lang.String listen_address

    - #### listen_interface

          public java.lang.String listen_interface

    - #### listen_interface_prefer_ipv6

          public java.lang.Boolean listen_interface_prefer_ipv6

    - #### broadcast_address

          public java.lang.String broadcast_address

    - #### listen_on_broadcast_address

          public java.lang.Boolean listen_on_broadcast_address

    - #### internode_authenticator

          public java.lang.String internode_authenticator

    - #### start_rpc

          public java.lang.Boolean start_rpc

    - #### rpc_address

          public java.lang.String rpc_address

    - #### rpc_interface

          public java.lang.String rpc_interface

    - #### rpc_interface_prefer_ipv6

          public java.lang.Boolean rpc_interface_prefer_ipv6

    - #### broadcast_rpc_address

          public java.lang.String broadcast_rpc_address

    - #### rpc_port

          public java.lang.Integer rpc_port

    - #### rpc_listen_backlog

          public java.lang.Integer rpc_listen_backlog

    - #### rpc_server_type

          public java.lang.String rpc_server_type

    - #### rpc_keepalive

          public java.lang.Boolean rpc_keepalive

    - #### rpc_min_threads

          public java.lang.Integer rpc_min_threads

    - #### rpc_max_threads

          public java.lang.Integer rpc_max_threads

    - #### rpc_send_buff_size_in_bytes

          public java.lang.Integer rpc_send_buff_size_in_bytes

    - #### rpc_recv_buff_size_in_bytes

          public java.lang.Integer rpc_recv_buff_size_in_bytes

    - #### internode_send_buff_size_in_bytes

          public java.lang.Integer internode_send_buff_size_in_bytes

    - #### internode_recv_buff_size_in_bytes

          public java.lang.Integer internode_recv_buff_size_in_bytes

    - #### start_native_transport

          public java.lang.Boolean start_native_transport

    - #### native_transport_port

          public java.lang.Integer native_transport_port

    - #### native_transport_max_threads

          public java.lang.Integer native_transport_max_threads

    - #### native_transport_max_frame_size_in_mb

          public java.lang.Integer native_transport_max_frame_size_in_mb

    - #### native_transport_max_concurrent_connections

          public volatile java.lang.Long native_transport_max_concurrent_connections

    - #### native_transport_max_concurrent_connections_per_ip

          public volatile java.lang.Long native_transport_max_concurrent_connections_per_ip

    - #### thrift_max_message_length_in_mb

          @Deprecated
          public java.lang.Integer thrift_max_message_length_in_mb

      Deprecated.

    - #### thrift_framed_transport_size_in_mb

          public java.lang.Integer thrift_framed_transport_size_in_mb

    - #### snapshot_before_compaction

          public java.lang.Boolean snapshot_before_compaction

    - #### auto_snapshot

          public java.lang.Boolean auto_snapshot

    - #### column_index_size_in_kb

          public java.lang.Integer column_index_size_in_kb

    - #### batch_size_warn_threshold_in_kb

          public volatile int batch_size_warn_threshold_in_kb

    - #### batch_size_fail_threshold_in_kb

          public volatile int batch_size_fail_threshold_in_kb

    - #### unlogged_batch_across_partitions_warn_threshold

          public java.lang.Integer unlogged_batch_across_partitions_warn_threshold

    - #### concurrent_compactors

          public java.lang.Integer concurrent_compactors

    - #### compaction_throughput_mb_per_sec

          public volatile java.lang.Integer compaction_throughput_mb_per_sec

    - #### compaction_large_partition_warning_threshold_mb

          public volatile java.lang.Integer compaction_large_partition_warning_threshold_mb

    - #### max_streaming_retries

          @Deprecated
          public java.lang.Integer max_streaming_retries

      Deprecated. retry support removed on CASSANDRA-10992

    - #### stream_throughput_outbound_megabits_per_sec

          public volatile java.lang.Integer stream_throughput_outbound_megabits_per_sec

    - #### inter_dc_stream_throughput_outbound_megabits_per_sec

          public volatile java.lang.Integer inter_dc_stream_throughput_outbound_megabits_per_sec

    - #### data_file_directories

          public java.lang.String[] data_file_directories

    - #### saved_caches_directory

          public java.lang.String saved_caches_directory

    - #### commitlog_directory

          public java.lang.String commitlog_directory

    - #### commitlog_total_space_in_mb

          public java.lang.Integer commitlog_total_space_in_mb

    - #### commitlog_sync

          public Config.CommitLogSync commitlog_sync

    - #### commitlog_sync_batch_window_in_ms

          public java.lang.Double commitlog_sync_batch_window_in_ms

    - #### commitlog_sync_period_in_ms

          public java.lang.Integer commitlog_sync_period_in_ms

    - #### commitlog_segment_size_in_mb

          public int commitlog_segment_size_in_mb

    - #### commitlog_compression

          public ParameterizedClass commitlog_compression

    - #### commitlog_max_compression_buffers_in_pool

          public int commitlog_max_compression_buffers_in_pool

    - #### commitlog_periodic_queue_size

          @Deprecated
          public int commitlog_periodic_queue_size

      Deprecated.

    - #### endpoint_snitch

          public java.lang.String endpoint_snitch

    - #### dynamic_snitch

          public java.lang.Boolean dynamic_snitch

    - #### dynamic_snitch_update_interval_in_ms

          public java.lang.Integer dynamic_snitch_update_interval_in_ms

    - #### dynamic_snitch_reset_interval_in_ms

          public java.lang.Integer dynamic_snitch_reset_interval_in_ms

    - #### dynamic_snitch_badness_threshold

          public java.lang.Double dynamic_snitch_badness_threshold

    - #### request_scheduler

          public java.lang.String request_scheduler

    - #### request_scheduler_id

          public Config.RequestSchedulerId request_scheduler_id

    - #### request_scheduler_options

          public RequestSchedulerOptions request_scheduler_options

    - #### server_encryption_options

          public EncryptionOptions.ServerEncryptionOptions server_encryption_options

    - #### client_encryption_options

          public EncryptionOptions.ClientEncryptionOptions client_encryption_options

    - #### encryption_options

          public EncryptionOptions.ServerEncryptionOptions encryption_options

    - #### internode_compression

          public Config.InternodeCompression internode_compression

    - #### index_interval

          @Deprecated
          public java.lang.Integer index_interval

      Deprecated.

    - #### hinted_handoff_throttle_in_kb

          public int hinted_handoff_throttle_in_kb

    - #### batchlog_replay_throttle_in_kb

          public int batchlog_replay_throttle_in_kb

    - #### max_hints_delivery_threads

          public int max_hints_delivery_threads

    - #### sstable_preemptive_open_interval_in_mb

          public int sstable_preemptive_open_interval_in_mb

    - #### incremental_backups

          public volatile boolean incremental_backups

    - #### trickle_fsync

          public boolean trickle_fsync

    - #### trickle_fsync_interval_in_kb

          public int trickle_fsync_interval_in_kb

    - #### key_cache_size_in_mb

          public java.lang.Long key_cache_size_in_mb

    - #### key_cache_save_period

          public volatile int key_cache_save_period

    - #### key_cache_keys_to_save

          public volatile int key_cache_keys_to_save

    - #### row_cache_class_name

          public java.lang.String row_cache_class_name

    - #### row_cache_size_in_mb

          public long row_cache_size_in_mb

    - #### row_cache_save_period

          public volatile int row_cache_save_period

    - #### row_cache_keys_to_save

          public volatile int row_cache_keys_to_save

    - #### counter_cache_size_in_mb

          public java.lang.Long counter_cache_size_in_mb

    - #### counter_cache_save_period

          public volatile int counter_cache_save_period

    - #### counter_cache_keys_to_save

          public volatile int counter_cache_keys_to_save

    - #### memory_allocator

          @Deprecated
          public java.lang.String memory_allocator

      Deprecated.

    - #### file_cache_size_in_mb

          public java.lang.Integer file_cache_size_in_mb

    - #### inter_dc_tcp_nodelay

          public boolean inter_dc_tcp_nodelay

    - #### memtable_allocation_type

          public Config.MemtableAllocationType memtable_allocation_type

    - #### outboundBindAny

          @Deprecated
          protected static boolean outboundBindAny

      Deprecated. No longer needed for streaming protocol. See CASSANDRA-12673 for details.

    - #### tombstone_warn_threshold

          public volatile int tombstone_warn_threshold

    - #### tombstone_failure_threshold

          public volatile int tombstone_failure_threshold

    - #### index_summary_capacity_in_mb

          public volatile java.lang.Long index_summary_capacity_in_mb

    - #### index_summary_resize_interval_in_minutes

          public volatile int index_summary_resize_interval_in_minutes

    - #### gc_log_threshold_in_ms

          public int gc_log_threshold_in_ms

    - #### gc_warn_threshold_in_ms

          public int gc_warn_threshold_in_ms

    - #### tracetype_query_ttl

          public int tracetype_query_ttl

    - #### tracetype_repair_ttl

          public int tracetype_repair_ttl

    - #### otc_coalescing_strategy

          public java.lang.String otc_coalescing_strategy

    - #### otc_coalescing_window_us_default

          public static final int otc_coalescing_window_us_default

      See Also:
        Constant Field Values

    - #### otc_coalescing_window_us

          public int otc_coalescing_window_us

    - #### otc_coalescing_enough_coalesced_messages

          public int otc_coalescing_enough_coalesced_messages

    - #### windows_timer_interval

          public int windows_timer_interval

    - #### enable_user_defined_functions

          public boolean enable_user_defined_functions

  - ### Constructor Detail

    - #### Config

          public Config()

  - ### Method Detail

    - #### getOutboundBindAny

          public static boolean getOutboundBindAny()

    - #### setOutboundBindAny

          public static void setOutboundBindAny(boolean value)

    - #### isClientMode

          public static boolean isClientMode()

    - #### setClientMode

          public static void setClientMode(boolean clientMode)

    - #### configHintedHandoff

          public void configHintedHandoff()
                                   throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### parseHintedHandoffEnabledDCs

          public static java.util.List<java.lang.String> parseHintedHandoffEnabledDCs(java.lang.String dcNames)
                                                                               throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### log

          public static void log(Config config)

Copyright © 2018 The Apache Software Foundation